#include <SDL.h>
#include "SDL_helper.hpp"
#include "Level.hpp"

#define NB_LEVELS 8

#include "levels_data.cpp"

Level * GetLevel( int level_no)
{
   if ( level_no > NB_LEVELS-1 )
     level_no = NB_LEVELS-1;
 
   Level * level = new Level;
 
   void *back_data = back1;
   void *brik_data = brik1;
   
   switch( level_no)
     {
      case 1: back_data=back1; brik_data=brik1; break;
      case 2: back_data=back2; brik_data=brik2; break;
      case 3: back_data=back3; brik_data=brik3; break;
      case 4: back_data=back4; brik_data=brik4; break;
      case 5: back_data=back5; brik_data=brik5; break;
      case 6: back_data=back6; brik_data=brik6; break;
      case 7: back_data=back7; brik_data=brik7; break;
      case 8: back_data=back8; brik_data=brik8; break;
//      case 9: back_data=back9; brik_data=brik9; break;
     }
   
   SDL_RWops *back_rw = SDL_RWFromConstMem((const void *)back_data, sizeof( back1));
   
   level->background = VSDL_LoadImage_RW( back_rw, 0);
   
   SDL_RWops *brik_rw = SDL_RWFromConstMem((const void *)brik_data, sizeof( back1));
   
   level->piece_sprite = VSDL_LoadImage_RW( brik_rw, 1);
   
   return level;
}

void DeleteLevel( Level *level)
{
   SDL_FreeSurface( level->piece_sprite);
   SDL_FreeSurface( level->background);
}
