#include <string.h>
#include "SDL_helper.hpp"
#include "Piece.hpp"

Piece::Piece()
{ 
   posX = 4;
   posY = 0;
   rot = 0;
}

Piece::~Piece() 
{
}

void Piece::SetType( int ntype)  {
   
   switch( ntype ) 
     { 
      case 1: strcpy( base,"0100010001000100"); break;
      case 2: strcpy( base,"0000010001000110"); break;
      case 3: strcpy( base,"0000001000100110"); break;
      case 4: strcpy( base,"0000001001100100"); break;
      case 5: strcpy( base,"0000010001100010"); break;
      case 6: strcpy( base,"0000011001100000"); break;
      case 7: strcpy( base,"0000010001100100"); break;
     }
   
   type = ntype;
   rot = 0;
   strcpy( shape, base );
}

void Piece::Display( int Ox, int Oy, SDL_Surface *sprite) 
{
   int x, y;
   
   for( y=0 ; y<4 ; y++)
     for( x=0 ; x<4 ; x++)
       if ( shape[y*4+x] == '1' ) 
	 {
	    SDL_Rect dest;
	    dest.x = Ox+(posX+x)*20;
	    dest.y = Oy+(posY+y)*20;
	    dest.w = sprite->w;
	    dest.h = sprite->h;
	    SDL_BlitSurface( sprite, NULL, SDL_GetVideoSurface(), &dest);
	 }
}

void Piece::Rotate( int rot)
{
   int i, j, r;
   char buf[256];
   
   strncpy( shape, base, 16);
   
   for( r = 0 ; r < rot ; r++) 
     {
	strncpy( buf, shape, 16);
	
	for(j=0;j<4;j++)
	  for(i=0;i<4;i++)
	    shape[(3-i)*4+j] = buf[j*4+i];
     }
}

void Piece::Move( int direction)
{
   
   lastRot = rot ;
   lastPosX = posX ;
   lastPosY = posY ;
   
   if ( direction == MOVE_ROT )
     {
	rot++ ;
	if ( rot > 3 )
	  rot = 0 ;
	Rotate( rot) ;
     }
   else if ( direction == MOVE_RIGHT )
     {	
	posX = posX + 1;
     }
   else if ( direction == MOVE_DOWN )
     {
	posY = posY  + 1;
     }
   else // direction == MOVE_LEFT
     {
	posX = posX - 1 ;
     }
}

void Piece::Undo()
{
   posX = lastPosX ;
   posY = lastPosY ;
   rot = lastRot ;
   Rotate( rot) ;
}
