#ifndef _PIECE_HPP
#define _PIECE_HPP

#define MOVE_ROT    1
#define MOVE_RIGHT  2
#define MOVE_DOWN   4
#define MOVE_LEFT   8

class Board;
struct SDL_Surface;

class Piece
{
 public:
   Piece();
   ~Piece();
   void SetType( int ntype);
   void SetTexture( char* ntexture);
   void Display( int Ox, int Oy, SDL_Surface *sprite);
   void Move( int direction);
   void Rotate( int rot);
   void Undo();
   //private:
   int posX;
   int posY;
   int rot;
   int type;
   char shape[4*4+1];
   char base[4*4+1];
 
 private:
   int lastPosX;
   int lastPosY;
   int lastRot;
};

#endif /* PIECE_HPP */
