#ifndef _SDL_HELPER_HPP
#define _SDL_HELPER_HPP

#include <SDL.h>

/* VSDL_Write */
#define VSDL_LEFT       0
#define VSDL_CENTERED   1
#define VSDL_RIGHT      2
#define VSDL_JUSTIFIED  4

struct VSDL_Fonts
{
   SDL_Surface *surface;
   int w;
   int h;
};

extern Uint32 waitFrame( Uint32 fps);

extern SDL_Surface *VSDL_LoadImage( char* filename, int tr=0, int alpha=0);

extern SDL_Surface *VSDL_LoadImage_RW( SDL_RWops *rw, int tr=0, int alpha=0);

extern VSDL_Fonts* VSDL_LoadFonts( char* filename, int fw, int fh);

extern VSDL_Fonts* VSDL_LoadFonts_RW( SDL_RWops *rw, int fw, int fh);

extern int VSDL_SetFonts( VSDL_Fonts* fonts);

extern int VSDL_Write( int x, int y, char* txt, int flags); 

extern int VSDL_FreeFonts( VSDL_Fonts* fonts);

#endif
