#include <stdlib.h>
#include <stdio.h>

#define NB_BYTES_PER_LINE 8

int main( int argc, char **argv)
{
   unsigned char buffer[8];
   int buffer_used;
   
   if ( argc < 4 )
     {
	fprintf( stderr, "usage: %s <data_file> <output_file.c> <data_name>\n");
	exit( EXIT_FAILURE);	
     }
   
   FILE* data_file = fopen( argv[1], "r");
   
   if ( data_file == NULL )
     {
	fprintf( stderr, "%s: can't open input data file %s\n", argv[1]);
	exit( EXIT_FAILURE);
     }
   
   FILE* output_file = fopen( argv[2], "a");
   
   if ( output_file == NULL)
     {
	fprintf( stderr, "%s: can't open output data file %s\n", argv[2]);
	exit( EXIT_FAILURE);
     }
   
   fprintf( output_file, "unsigned char %s[] = { \n", argv[3]);
   
   buffer_used = 1;
   
   while( buffer_used != 0)
     {
	int i;
	
	buffer_used = fread( buffer, sizeof( unsigned char), NB_BYTES_PER_LINE, data_file); 
     
	for( i = 0 ; i < buffer_used ; i++)
	  fprintf( output_file, "0x%02x, ", buffer[i]);
	
	fprintf( output_file, "\n");
     }
   
   fprintf( output_file, "};\n");
   
   fclose( data_file);
   fclose( output_file);
   
   fprintf( stdout, "Done\n");
}
