#include <stdlib.h>
#include <stdio.h>
#include <SDL.h>
#include "Board.hpp"
#include "SDL_helper.hpp"

int game() {
   SDL_Event event;
   Board* board;

   board = new Board();
   board->LoadLevel( 1);
   
   while( 1) 
     {
	while( SDL_PollEvent( &event) ) 
	  {      
	     if ( (event.type==SDL_QUIT) || ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE)) 
	       {
		  delete board;
		  SDL_Quit();
		  exit( EXIT_SUCCESS);
	       }
	     else if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_UP)
	       {
		  board->MovePlayer( MOVE_ROT) ;	 
	       }
	     else if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_DOWN)
	       {
		  board->MovePlayer( MOVE_DOWN) ;	 
	       }
	     else if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_LEFT)
	       {
		  board->MovePlayer( MOVE_LEFT) ;	 
	       }
	     else if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_RIGHT)
	       {
		  board->MovePlayer( MOVE_RIGHT) ;	 
	       }     
	  }
	
	if ( board->Update() == 1 ) 
	  {
	     SDL_Quit() ;
	     fprintf( stdout, " You lost ! \n") ;
	     exit( EXIT_SUCCESS) ;
	  }
	
	board->Display();
	
	waitFrame( 50);
	
	// Refresh screen
	SDL_Flip( SDL_GetVideoSurface());
     }
}

