/*
  -+-------------------------------------------------------------------------+-
    Tetriste                                           Release 0.1 June 2000
                         
                          -+------------------+-
                             The Main Program
                          -+------------------+-

  -+------------------------------------------------------------------------+- 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Jean-Christophe Duberga, 
    jeanchristophe.duber@free.fr
    10, Rue Solesse
    33290 BLANQUEFORT
    FRANCE
  -+-------------------------------------------------------------------------+-
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <SDL.h>
#include "SDL_helper.hpp"
#include "fonts_comic.cpp"

extern int game();

int main( int argc, char **argv)
{   
   Uint32 sdl_video_flags = 0;
   
   for( int a = 1 ; a < argc ; a++) 
     {
	if ( strcmp( argv[a], "--help") == 0 ) 
	  {
	     fprintf( stderr, "usage: %s [options]\n\n", argv[0]) ;
	     fprintf( stderr, "options are:\n") ;
	     fprintf( stderr, "  --help             Display this help notice\n") ;
	     fprintf( stderr, "  --fullscreen       Fullscreen mode (default: no)\n") ;
	     exit( EXIT_FAILURE) ;
	  }
	else if ( strcmp( argv[a], "--fullscreen") == 0 )
	  sdl_video_flags |= SDL_FULLSCREEN;
	else
	  fprintf( stderr, "%s: unknow parameter %s\n", argv[0], argv[a]);
     }
   
   // Init SDL and create a window
   
   fprintf( stdout, "Thank you for trying TetrisTe\n") ;

   if ( SDL_Init( SDL_INIT_VIDEO) < 0 ) 
     {
	fprintf(stderr,"%s: couldn't init video\n", argv[0]);
	exit( EXIT_FAILURE);
     }
   
   if ( SDL_SetVideoMode( 640, 480, 0, sdl_video_flags) == NULL ) 
     {
	fprintf(stderr, "Couldn't set %dx%dxanybpp video mode: %s\n",
		640, 480, SDL_GetError());
	exit( EXIT_FAILURE);
     }
      
   SDL_ShowCursor( 0);

   SDL_EnableKeyRepeat( 200, SDL_DEFAULT_REPEAT_INTERVAL);
   
   SDL_RWops *fonts_rw = SDL_RWFromConstMem((const void *)fonts_comic, sizeof( fonts_comic));
   VSDL_Fonts *fonts = VSDL_LoadFonts_RW( fonts_rw, 25, 25); 
   VSDL_SetFonts( fonts);
   
   //VSDL_OpenMixer( 22049, 16, 2);                           
       
   int state = 1;
   
   while(1) 
     {
	// TODO: ADD A DEMO, HISCORE...
	
	switch( state) 
	  {
	   case 1: game() ; break ;
	  }
     }
}
